#ifndef __EREPLICACOMPONENTTYPE__H__
#define __EREPLICACOMPONENTTYPE__H__

#include <cstdint>

enum class eReplicaComponentType : uint32_t {
	INVALID = 0,
	CONTROLLABLE_PHYSICS,
	RENDER,
	SIMPLE_PHYSICS,
	CHARACTER,
	SCRIPT,
	BOUNCER,
	BUFF, // buff is really 98, this is DESTROYABLE
	GHOST,
	SKILL,
	SPAWNER,
	ITEM,
	REBUILD,
	REBUILD_START,
	REBUILD_ACTIVATOR,
	ICON_ONLY,
	VENDOR,
	INVENTORY,
	PROJECTILE_PHYSICS,
	SHOOTING_GALLERY,
	RIGID_BODY_PHANTOM_PHYSICS,
	DROP_EFFECT,
	CHEST,
	COLLECTIBLE,
	BLUEPRINT,
	MOVING_PLATFORM,
	PET,
	PLATFORM_BOUNDARY,
	MODULE,
	ARCADE,
	VEHICLE_PHYSICS, // Havok demo based
	MOVEMENT_AI,
	EXHIBIT,
	OVERHEAD_ICON,
	PET_CONTROL,
	MINIFIG,
	PROPERTY,
	PET_CREATOR,
	MODEL_BUILDER,
	SCRIPTED_ACTIVITY,
	PHANTOM_PHYSICS,
	SPRINGPAD,
	MODEL,
	PROPERTY_ENTRANCE,
	FX,
	PROPERTY_MANAGEMENT,
	VEHICLE_PHYSICS_NEW, // internal physics based on havok
	PHYSICS_SYSTEM,
	QUICK_BUILD,
	SWITCH,
	ZONE_CONTROL, // Minigame
	CHANGLING,
	CHOICE_BUILD,
	PACKAGE,
	SOUND_REPEATER,
	SOUND_AMBIENT_2D,
	SOUND_AMBIENT_3D,
	PRECONDITION,
	PLAYER_FLAG,
	CUSTOM_BUILD_ASSEMBLY,
	BASE_COMBAT_AI,
	MODULE_ASSEMBLY,
	SHOWCASE_MODEL_HANDLER,
	RACING_MODULE,
	GENERIC_ACTIVATOR,
	PROPERTY_VENDOR,
	HF_LIGHT_DIRECTION_GADGET,
	ROCKET_LAUNCH,
	ROCKET_LANDING,
	TRIGGER,
	DROPPED_LOOT,
	RACING_CONTROL,
	FACTION_TRIGGER,
	MISSION_OFFER,
	RACING_STATS,
	LUP_EXHIBIT,
	BBB,
	SOUND_TRIGGER,
	PROXIMITY_MONITOR,
	RACING_SOUND_TRIGGER,
	CHAT,
	FRIENDS_LIST,
	GUILD,
	LOCAL_SYSTEM,
	MISSION,
	MUTABLE_MODEL_BEHAVIORS,
	PATHFINDING,
	PET_TAMING_CONTROL,
	PROPERTY_EDITOR,
	SKINNED_RENDER,
	SLASH_COMMAND,
	STATUS_EFFECT,
	TEAMS,
	TEXT_EFFECT,
	TRADE,
	USER_CONTROL,
	IGNORE_LIST,
	ROCKET_LAUNCH_LUP,
	BUFF_REAL, // the real buff component, should just be name BUFF
	INTERACTION_MANAGER,
	DONATION_VENDOR,
	COMBAT_MEDIATOR,
	COMMENDATION_VENDOR,
	UNKNOWN_103,
	RAIL_ACTIVATOR,
	ROLLER,
	PLAYER_FORCED_MOVEMENT,
	CRAFTING,
	POSSESSABLE,
	LEVEL_PROGRESSION,
	POSSESSOR,
	MOUNT_CONTROL,
	UNKNOWN_112,
	PROPERTY_PLAQUE,
	BUILD_BORDER,
	UNKOWN_115,
	CULLING_PLANE,
	DESTROYABLE = 1000 // Actually 7
};

#endif  //!__EREPLICACOMPONENTTYPE__H__
